import { Coordinates } from '../core/application/types/coordinates.type';
import { DirectionEncoderPort } from '../core/application/ports/direction-encoder.port';
import { Injectable } from '@nestjs/common';

@Injectable()
export class PostgresDirectionEncoder implements DirectionEncoderPort {
  encode = (coordinates: Coordinates[]): string =>
    [
      "'LINESTRING(",
      coordinates.map((point) => [point.lon, point.lat].join(' ')).join(),
      ")'",
    ].join('');
}
